--------------------------------------------------------------------------
--DIMaster v2.0 
--MacroScript Definitions
--Last Edited: 2008/02/05
--Code by Borislav "Bobo" Petrov
--http://www.scriptspot.com/bobo 
--	"modified by Kostadin Kotev // miau_u@yahoo.com// http://miauumaxscript.blogspot.bg/"  september 2016
--	"added Auto Select Parent macro"
--	"added Help macro(to directly opn the Help file)"
--	"modified the DIMLineMulti to allow creations of lines without interrupting"
--------------------------------------------------------------------------

macroScript DIMline category:"DIMaster" icon:#("DIMaster",1) tooltip:"Create a DIMline measuring the distance between two points..."
(
	max create mode
	global DIMaster_p1 = undefined
	global DIMaster_p2 = undefined
	global DIMaster_p3 = undefined
	global DIMaster_theDim = undefined
	global DIMaster_firstPoint = undefined
	global DIMaster_theText = undefined
	
	local curSnapMode = snapMode.active
	local curSnapType = snapMode.type
	snapMode.active = true
	snapMode.type = #3D
	
	result = startTool createDimensionLine snap:#3D
	if result == #abort do 
	(
		try(delete DIMaster_theText)catch()
		try(delete DIMaster_p1)catch()
		try(delete DIMaster_p2)catch()
		try(delete DIMaster_theDim)catch()
	)	
	
	try(snapMode.active = curSnapMode)catch()
	try(snapMode.type = curSnapType)catch()
)

macroScript DIMangle category:"DIMaster" icon:#("DIMaster",2) tooltip:"Create a DIMangle measuring the angle between three points..."
(
	max create mode
	global DIMaster_p1 = undefined
	global DIMaster_p2 = undefined
	global DIMaster_p3 = undefined
	global DIMaster_theDim = undefined
	global DIMaster_firstPoint = undefined
	global DIMaster_theText = undefined
	
	local curSnapMode = snapMode.active
	local curSnapType = snapMode.type
	snapMode.active = true
	snapMode.type = #3D
	
	result = startTool createDimensionAngle snap:#3D
	if result == #abort do 
	(
		try(delete DIMaster_theText)catch()
		try(delete DIMaster_p1)catch()
		try(delete DIMaster_p2)catch()
		try(delete DIMaster_p3)catch()
		try(delete DIMaster_theDim)catch()
	)	
	
	try(snapMode.active = curSnapMode)catch()
	try(snapMode.type = curSnapType)catch()
)


macroScript DIMnote category:"DIMaster" icon:#("DIMaster",3) tooltip:"Create a DIMnote displaying position, distance, speed, custom object properties or user-defined text..."
(
	max create mode
	global DIMaster_p1 = undefined
	global DIMaster_p2 = undefined
	global DIMaster_p3 = undefined
	global DIMaster_theDim = undefined
	global DIMaster_firstPoint = undefined
	global DIMaster_theText = undefined
	
	local curSnapMode = snapMode.active
	local curSnapType = snapMode.type
	snapMode.active = true
	snapMode.type = #3D
	
	result = startTool createDimensionNote snap:#3D
	if result == #abort do 
	(
		try(delete DIMaster_theText)catch()
		try(delete DIMaster_p1)catch()
		try(delete DIMaster_p2)catch()
		try(delete DIMaster_p3)catch()
		try(delete DIMaster_theDim)catch()
	)	
	
	try(snapMode.active = curSnapMode)catch()
	try(snapMode.type = curSnapType)catch()
)

macroScript DIMlineMulti category:"DIMaster" icon:#("DIMaster",4) tooltip:"Create multiple horizontal or vertical DIMline objects. Finish with right mouse click. Press CTR-key to toggle to arbitrary direction."
(
	max create mode
	local isCheckedVar = false
	on isChecked return isCheckedVar 
	on execute do
	(
		isCheckedVar = true
		global DIMaster_p1 = undefined
		global DIMaster_p2 = undefined
		global DIMaster_p3 = undefined
		global DIMaster_theDim = undefined
		global DIMaster_firstPoint = undefined
		global DIMaster_theText = undefined
		
		global DIMaster_clickno_Cnt = 1
		
		local curSnapMode = snapMode.active
		local curSnapType = snapMode.type
		snapMode.active = true
		snapMode.type = #3D
		
		global DIMaster_Result = #go
		while DIMaster_Result != #abort do
		(
			DIMaster_clickno_Cnt = 1
			/* DIMaster_Result =  */startTool createDimensionLine snap:#3D
		)
		isCheckedVar = false
		
		try(snapMode.active = curSnapMode)catch()
		try(snapMode.type = curSnapType)catch()
	)	
)

macroScript DIMangleMulti category:"DIMaster" icon:#("DIMaster",5) tooltip:"Create multiple DIMangle objects measuring angles between sets of three points..."
(
	max create mode
	local isCheckedVar = false
	on isChecked return isCheckedVar 
	on execute do
	(
		isCheckedVar = true
		global DIMaster_p1 = undefined
		global DIMaster_p2 = undefined
		global DIMaster_p3 = undefined
		global DIMaster_theDim = undefined
		global DIMaster_firstPoint = undefined
		global DIMaster_theText = undefined
		
		local curSnapMode = snapMode.active
		local curSnapType = snapMode.type
		snapMode.active = true
		snapMode.type = #3D
		
		global DIMaster_Result = #go
		while DIMaster_Result != #abort do
		(
			/* DIMaster_Result =  */startTool createDimensionAngle snap:#3D
		)
		isCheckedVar = false
		
		try(snapMode.active = curSnapMode)catch()
		try(snapMode.type = curSnapType)catch()
	)	
)


macroScript DIMnoteMulti category:"DIMaster" icon:#("DIMaster",6) tooltip:"Create multiple DIMnote objects displaying positions, distances, speeds, custom object properties or user-defined texts..."
(
	max create mode
	local isCheckedVar = false
	on isChecked return isCheckedVar 
	on execute do
	(
		isCheckedVar = true
		global DIMaster_p1 = undefined
		global DIMaster_p2 = undefined
		global DIMaster_p3 = undefined
		global DIMaster_theDim = undefined
		global DIMaster_firstPoint = undefined
		global DIMaster_theText = undefined
		
		local curSnapMode = snapMode.active
		local curSnapType = snapMode.type
		snapMode.active = true
		snapMode.type = #3D
		
		global DIMaster_Result = #go
		while DIMaster_Result != #abort do
		(
			/* DIMaster_Result =  */startTool createDimensionNote snap:#3D
		)
		isCheckedVar = false
		
		try(snapMode.active = curSnapMode)catch()
		try(snapMode.type = curSnapType)catch()
	)	
)


macroScript DIMasterDelete category:"DIMaster" icon:#("DIMaster",7) tooltip:"Delete DIMaster objects whose elements (Points, Lines or Texts) are currently selected..."
(
	max create mode
	with undo "DIMaster Delete" on
	(
		theSel = selection as array
		for o in theSel where isValidNode o do 
		(
			::DIMaster_Result = #abort
			try(stopTool createDimensionLine)catch()
			try(stopTool createDimensionAngle)catch()
			try(stopTool createDimensionNote)catch()
			DIMasterFunctions.DeleteCallback o			
		)
		redrawViews()
	)
)

macroScript DIMasterAttach category:"DIMaster" icon:#("DIMaster",8) tooltip:"Toggle Attaching the DIMaster object's Control Points to Snapped Points on Geometry Objects. Requires 3D Snaps."
(
	global DIMaster_AttachToSnapped
	on isChecked return DIMaster_AttachToSnapped == true
	on execute do
	(
		if DIMaster_AttachToSnapped == undefined do DIMaster_AttachToSnapped = false
		DIMaster_AttachToSnapped = not DIMaster_AttachToSnapped
	)	
)

macroScript DIMasterAutoSelectParent category:"DIMaster" icon:#("DIMaster",10) tooltip:"Move DIMLine. Automatically select parent when any DIMLine object is selected."
(
	global DIMasterSelectParent
	global DIMasterSelectParentNEC
	global DIMasterAutoSelectParentBol
	
	on isChecked return DIMasterAutoSelectParentBol == true
	on execute do
	(
		function DIMasterSelectParent evnt nodes =
		(
			with undo off
			(
				if selection.count == 1 do
				(
					DIMaster_object = selection[1]
					if classof DIMaster_object == DIMline do
					(
						parentNode = DIMaster_object.node01.parent
						if parentNode != undefined then
						(
							if isValidNode parentNode do select parentNode
						)
						else
						(
							select DIMaster_object.node01
						)
					)
				)
			)
		)
	
		if DIMasterAutoSelectParentBol == undefined do DIMasterAutoSelectParentBol = false
		DIMasterAutoSelectParentBol = not DIMasterAutoSelectParentBol
		if DIMasterAutoSelectParentBol == true then 
		(
			DIMasterSelectParentNEC = NodeEventCallback selectionChanged:DIMasterSelectParent
		)
		else
		(
			--	"do it twice, just in case"
			DIMasterSelectParentNEC = undefined
			gc light:true
			DIMasterSelectParentNEC = undefined
			gc light:true
		)
	)	
)

macroScript DIMasterHelp category:"DIMaster" icon:#("DIMaster",9) tooltip:"Show the Help"
(
	helpFileDirPath = "C:\\3dsMax_DIMaster\\"
-- 	helpFileDirPath = (pathConfig.GetDir (#scripts)) + "\\DIMaster\\"
	helpFile = helpFileDirPath + "DIMaster.chm"
	if doesFileExist helpFile then
		shellLaunch helpFile ""
	else
		messagebox "Help file is missing. Reinstall DIMaster" title:"WARNING"
)
